"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _useSetting = _interopRequireDefault(require("./use-setting"));

var _constants = require("./constants");

var _hooks = require("./hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function useAuthentication(app) {
  const [isAuthenticated, setIsAuthenticated] = (0, _useSetting.default)(app, _constants.IS_AUTHENTICATED, null);
  (0, _react.useEffect)(() => {
    async function checkStorage() {
      let value;

      try {
        await app.authenticate();
        value = true;
      } catch (err) {
        value = false;
      }

      setIsAuthenticated(value);
    }

    if (app.get(_constants.HAS_ATTEMPTED_AUTHENTICATION)) {
      return;
    }

    app.set(_constants.HAS_ATTEMPTED_AUTHENTICATION, true);
    checkStorage();
  }, [app, setIsAuthenticated]);
  (0, _hooks.useEventEmitter)(app, 'authenticated', (0, _react.useCallback)(() => {
    setIsAuthenticated(true);
  }, [setIsAuthenticated]));
  (0, _hooks.useEventEmitter)(app, 'logout', (0, _react.useCallback)(() => {
    setIsAuthenticated(false);
  }, [setIsAuthenticated]));
  (0, _react.useDebugValue)(isAuthenticated);
  return isAuthenticated;
}

var _default = useAuthentication;
exports.default = _default;
//# sourceMappingURL=use-authentication.js.map